10/04/2008 Release Notes For FwDIM v15r07:

Linked with:
    - DIM v17r04

Ready for:
    - PVSS 3.6 (only)
    - Linux executables built on: SLC4 with gcc 3.4.6

Bug Fixes / Improvements:
    - Upgrade to DIM v17r4
    - Fixed a bug in PVSS00dim that made it consume a lot of CPU time even when idle.


27/03/2008 Release Notes For FwDIM v15r06:

Linked with:
    - DIM v17r03

Ready for:
    - PVSS 3.6 (only)
    - Linux executables built on: SLC4 with gcc 3.4.6

Bug Fixes / Improvements:
    - Fixed the installation, now it stops any PVSS00dim managers
      and restarts them only when installation has finished.
    - Incleased the Hash Table size in PVSS00dim


08/02/2008 Release Notes For FwDIM v15r05:

Linked with:
    - DIM v17r01

Ready for:
    - PVSS 3.6 (only)
    - Linux executables built on: SLC4 with gcc 3.4.6

Bug Fixes / Improvements:
    - PVSS00dim now accepts PVSS ints and floats as DIM "C" services
      it will convert them to ints or floats depending on the dp element type
    - When sending commands "files" (the file content is sent instead of the file)
      The file was beeing read immediately at startup which was slow and unnecessary.
      Now the file is read only when the command is sent. 


20/01/2008 Release Notes For FwDIM v15r04:

Linked with:
    - DIM v17r01

Ready for:
    - PVSS 3.6 (only)
    - Linux executables built on: SLC4 with gcc 3.4.6

Bug Fixes / Improvements:
    - Latest version of DIM
    - The functions fwDIM_subscribeServices, etc. now return the number of newly
      subscribed services.
    - Fixed some bug in the DIM RPC handling
    - Fixed a bug in PVSS00dim. It crashed when the "config" name was longer than 32
      characters.


22/11/2007 Release Notes For FwDIM v15r03:

Linked with:
    - DIM v16r13

Ready for:
    - PVSS 3.6 (only)
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - Optimized the Unsubscription of many services by creating new functions:
	fwDim_unSubscribeServicesNoWild 
	fwDim_unSubscribeCommandsNoWild 
        These are variands of unSubscribeXXXbyDp but instead of accepting wildcards
        they accept a list of dpNames.


26/07/2007 Release Notes For FwDIM v15r02:

Linked with:
    - DIM v16r13

Ready for:
    - PVSS 3.6 (only)
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - A DIM Config (dp) could not contain "_". Fixed. 


13/06/2007 Release Notes For FwDIM v15r01:

Linked with:
    - DIM v16r13

Ready for:
    - PVSS 3.6 (only)
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - The PVSS00dim mechanism of sending a command can be very slow the first time the 
      command is sent or setup if there are many subscribed commands, since it has to ask 
      the DNS the DIM format for each one of them.
      Now when subscribing a command the user can specify directly the format of the command
      so that PVSS00dim doesn't need to ask the DNS. This an optional parameter at the end of
      fwDim_subscribeCommand and fwDim_subscribeCommands.
    - A bug that has probably been around for a long time was found:
      The "update Interval" parameter when subscribing to services was supposed to mean 
      the following:
	0 - On Change -> was supposed to trigger an old/new comparison when the value was
                         received from a server.
        -1 -> was supposed to pass to PVSS all values received from the server.
      This old/new comparison had stopped working for a long time. So the behaviour was the same
      for 0 or -1.
      In order not to break applications that were probably relying on this behaviour, this
      will be maintained: 0 or -1 will pass to PVSS any value received from the server, and a 
      new value for this parameter: -2 was introduced for the old/new comparison. 


18/05/2007 Release Notes For FwDIM v14r22:

Linked with:
    - DIM v16r13

Ready for:
    - PVSS 3.6 (only)
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - Uses a later DIM version
    - When a config was empty an error prevented panels and functions tu use it - fized.
    - PVSS00dim sometimes crashed while unpublishing services - fixed.
 

22/01/2007 Release Notes For FwDIM v14r21:

Linked with:
    - DIM v16r9

Ready for:
    - PVSS 3.0 and 3.6
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - Fixed a bug in DIM (Servers with duplicated services were not killed anymore)
    - Corrected the PVSS 3.6 PVSS00dim startup script for Linux SLC4
  

10/01/2007 Release Notes For FwDIM v14r20:

Linked with:
    - DIM v16r8

Available for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - Intruduced a new type of "Command Subscription":
	- "fwDim_subscribeFileCommand()"
      This allows the user to subscribe to an item or a structure in which the
      item (or last item of the structure) is a file name to be replaced at run 
      time by the actual file contents (binary or ascii).
        - This feature is also available from the FwDIM panels
  
    *********************** READY FOR PVSS 3.6 *******************************	


21/12/2006 Release Notes For FwDIM v14r19:

Linked with:
    - DIM v16r8

Available for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - Fixed a bug introduced in v14r15, The "default" values were not received
      correctly by the PVSS datapoints for integer values. 
      (when the DIM service was not available)
  
    *********************** READY FOR PVSS 3.6 *******************************	


12/12/2006 Release Notes For FwDIM v14r18:

Linked with:
    - DIM v16r8

Available only for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - Fixed a bug in fwDIM (dpWait) libraries used by FwSpecs and FwCcpc 
      *********************** READY FOR PVSS 3.6 *******************************	


30/11/2006 Release Notes For FwDIM v14r17:

Linked with:
    - DIM v16r8

Available only for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - Some bugs prevented it to work on PVSS 3.6 on Linux - Fixed.
      *********************** READY FOR PVSS 3.6 *******************************	


21/11/2006 Release Notes For FwDIM v14r16:

Linked with:
    - DIM v16r8

Available only for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - Same as v14r15, but:
      *********************** READY FOR PVSS 3.6 *******************************	

 
31/10/2006 Release Notes For FwDIM v14r15:

Linked with:
    - DIM v16r8

Available only for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - PVSS00dim now accepts DIM shorts and short arrays to go into PVSS as int and dyn_int.
    - the fwDIM functions now work across distributed systems if the "config" parameter
      contains the system name.
    - FwDIM also allows subscribing or publishing datapoint elements in remote distributed
      systems. Fixed a bug in the FwDIM panel to show their values.
    - Fixed a bug that prevented PVSS00dim to subscribe properly to servers that had just
      started (the service format was not known yet).
 

31/08/2006 Release Notes For FwDIM v14r14:

Linked with:
    - DIM v16r7

Available only for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - Added some general purpose functions:
	fwDim_dpWaitClear() and fwDim_dpWait()
    - For some reason the PVSS00dim of the latest version seemed to have some linking
      problem, so added a new relinked one (v16r7).
 

22/08/2006 Release Notes For FwDIM v14r13:

Linked with:
    - DIM v16r6

Available only for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - Fixed dim_lock, the mutual exclusion semaphore did not work between two threads of the
      same manager (only between different managers).
 

12/05/2006 Release Notes For FwDIM v14r12:

Linked with:
    - DIM v16r6

Available only for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - A bug was introduced in the latest version: The DIM_DNS_NODE set via the command
      line option "-dim_dns_node" was not completely taken into account. Fixed.
    - Allowed the user to set also the DIM_DNS_PORT using the format:
	DIM_DNS_NODE[:DIM_DNS_PORT]
      Either from the fwDim panel, using the fwDim function library or via the 
      "-dim_dns_node" command line option. 


01/05/2006 Release Notes For FwDIM v14r11:

Linked with:
    - DIM v16r5

Available only for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - Fixed a bug that prevented using the functions fwDIM_findXXX simultaneously from more 
      than one PVSS managers. Access to The DNS information is now protected by a 
      "PVSS semaphone".
    - When optimizing the reception of DIM services into PVSS datapoints, a bug had been 
      introduced, and some consecutive updates for the same datapoint were discarded. 
      This is now Fixed. All DIM service updates should get into the datapoints.  


30/03/2006 Release Notes For FwDIM v14r10:

Linked with:
    - DIM v16r2

Available only for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - Linked with DIM v16r2 to avoid "Connection Refused" Erros and to be in sync with FwFSM 


28/02/2006 Release Notes For FwDIM v14r9:

Linked with:
    - DIM v16r1

Available only for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - Fixed a bug in the script library, errors were reported when unsubscribing services.
    - Optimised the reception of DIM Commands from PVSS.


31/01/2006 Release Notes For FwDIM v14r8:

Linked with:
    - DIM v16r0

Available only for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - When publishing "static" PVSS arrays an update was not generated on change - fixed.
    - The "format" string was not calculated properly in PVSS for static arrays - fixed.


05/01/2006 Release Notes For FwDIM v14r7:

Linked with:
    - DIM v16r0

Available only for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - Fixed another bug in the cache, appeared when removing and resubscribing service entries
    - Optimized PVSS00dim for better grouping of DP elements (when updates for the same datapoint
      were interleaved with updates for new ones). It now sends all the not repeated datapoints
      in one go (instead of just sending up to the first repeated one).   
 

05/12/2005 Release Notes For FwDIM v14r6:

Linked with:
    - DIM v16r0

Available only for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - Fixed a bug in the cache, appeared when removing service entries
    - In the last version one of the optimisations was that the DimConfig dp was
      not written immediately, the functions created a thread that would wait 1 second
      and if there was no change in the meantime would then update the dp. 
    	- Created a flag to disable this optimisation, since if the users used for
          example execScript() this thread would be killed prematurely and the dp
          would never be updated.   
 

15/11/2005 Release Notes For FwDIM v14r5:

Linked with:
    - DIM v16r0

Available only for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - Optimized PVSS00dim for handling many services, in particular:
	- Added a hash table to store the list of services.
    	- Optimized the grouping of datapoints in a single dpSet (but breaking
	  the grouping when more than one value for the same DP).
    - PVSS00dim now handles doubles, it used to convert them to floats.
    - PVSS00dim now also accepts a "-dim_dns_port NNN" command line parameter

    - Optimized also the fwDim script library:
	- Also contains a hash table to speed up the check of whether services
	  already exist.
          The hash code is also stored in the DimConfig datapoint.
        - Also added a cache for multiple consecutive subscriptions to the same
	  DimConfig.
	- fwDim functions now use the library fwDimCacheHash.ctl

    - Removed (temporarily) the setting of the address config fot datapoint elements
      subscribing to DIM services. It takes too long (10 minutes for 10000 dpes).
      To be understood.  

01/09/2005 Release Notes For FwDIM v14r4:

Linked with:
    - DIM v15r21
Available only for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - Includes a new version of DIM which fixed in particular a bug in the DNS:
        it would sometimes discard servers by mistake.


04/08/2005 Release Notes For FwDIM v14r3:

Linked with:
    - DIM v15r19
Available only for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - The Optimization for grouped dpSets of version v14r2 didn't work properly.
      dpSets can only be grouped if the group does not contain two values for the
      same dpElement - Fixed.
    - Fixed some small memory leaks
    - Last version needed an extra DLL: MSVCIRTD.DLL - Fixed.  


28/06/2005 Release Notes For FwDIM v14r2:

Linked with:
    - DIM v15r19
Available only for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - The alarm text published by DIM was sometimes corrupted - fixed.
    - Optimized the subscription and publishing of many services or commands at once.
    - Fixed some bugs in the fwDim panels.
    - Sometimes the first DIM command sent to a newly created server would be of size 0
      provoking the server to get a currupted command: fixed.
    - Modified the PVSS00dim startup procedure for Linux so that a version of PVSS00dim
      linked on SLC3 gcc3.2.3 finds its necessary PVSS libraries (RH90).
      It now starts a Shell script which defines the environment variables and then
      starts PVSS00dim.
    - Optimized for grouped dpSets 


21/04/2005 Release Notes For FwDIM v14r1:

Linked with:
    - DIM v15r13
Available only for:
    - PVSS 3.0 and above
    - Linux executables built on: SLC3 with gcc 3.2.3

Bug Fixes / Improvements:
    - Dynamic Elements as part of a folder structure:
	When publishing Services or commands dynamic elements and strings had to be
	the last element of a structure (so that PVSS00dim could compute a changing size)
	Now the user can specify a DIM format string for the published data structure
	either from the fwDIM panel or by using the fwDIM library functions.
	This format string has to specify a maximum size for each dynamic element
	except the last element of the structure.
	If the user wants to send data of varying size than this element should still be
	the last in the structure.
    - New "time" type
	The PVSS data types "time" and "dyn_time" have been implemented. They correspond
	in a C/C++ server/client to a variable of type time_t. Meaning that only the seconds
	are transfered.
    - Dynamic array of size 0
	An empty dynamic array was never transfered since a DIM service of size 0 was not
	transfered. This was fixed in DIM.
    - Publishing Alerts
	The user can now publish DPelement alerts as DIM services. This can be done 
	either from the fwDIM panel or by using the fwDIM library functions:
		fwDim_publishAlarmService
		fwDim_publishAlarmServices
		fwDim_unPublishAlarmServices
	For each DP element the following alarm properties will be bublished:
		boolean _alert_hdl.._active
		int	_alert_hdl.._act_state
		char	_alert_hdl.._act_prior 
		string	_alert_hdl.._act_text
	The corresponding DIM format string is: "C:1;I:1;C:1;C"
	Note: If publishing large number of alarms fwDim_publishAlarmServices is much
	      more efficient than fwDim_publishAlarmService


03/03/2005 Release Notes For FwDIM v13r7:

Linked with:
    - DIM v15r4
Available for:
    - PVSS 2.12, 2.12.1 and 3.0 Official Release

Bug Fixes / Improvements:
    - Now the user can browse when selecting a DIM Service for subscribing
      to a service or a command.
    - New DIMTree browser from Serguei

26/11/2004 Release Notes For FwDIM v13r6:

Linked with:
    - DIM v15r4
Available for:
    - PVSS 2.12, 2.12.1 and 3.0 Official Release

Bug Fixes / Improvements:
    - Uses DIM v15r4 (for compatibility with FwFSM)

18/10/2004 Release Notes For FwDIM v13r5:

Linked with:
    - DIM v15r1
Available for:
    - PVSS 2.12, 2.12.1 and 3.0 Official Release

Bug Fixes / Improvements:
    - Uses DIM v15r1 so it fixes the DNS limitation (64 servers/clients) for 
      Windows
    - Finally fixes the Linux installation. No need to define OS or OSTYPE
    - Automatically adds a DIM panel to the console 

21/09/2004 Release Notes For FwDIM v13r4:

Linked with:
    - DIM v15r0
Available for:
    - PVSS 2.12, 2.12.1 and 3.0 Official Release

Bug Fixes / Improvements:
    - Uses DIM v15r0 so it works on 64 bit machines 

10/08/2004 Release Notes For FwDIM v13r3:

Linked with:
    - DIM v14r7
Available for:
    - PVSS 2.12, 2.12.1 and 3.0 Official Release

Bug Fixes / Improvements:
    - PVSS00dim is now faster for ping-pong type operations, i.e. 
      when using DimRPCs
    - The DimDnsNode given using the FwDIM panel is remembered
    - When Dim Services are subscribed using fwDim_subscribeService(s)
      The _address config of the relevant datapoint elements is set to:
	_address.._type = DPCONFIG_PERIPH_ADDR_MAIN
	_address.._drv_ident = "DIM/"+config
		where config is the DIM config DP used
    - The FwDIM Installation tool now uses the Environment variable "OSTYPE"
      to decide whether it's Linux or Windows (used to be "OS")

27/05/2004 Release Notes For FwDIM v13r2:

Linked with:
    - DIM v14r2
Available for:
    - PVSS 2.12, 2.12.1 and 3.0 Official Release

Bug Fixes / Improvements:
    - Structured RPCs were not transfered properly into PVSS.
      Fixed (changes also in DIM v14r2)
    - Implemented missing PVSS types: 
	char, dyn_char, dyn_bit32 and dyn_bool
      Still missing: blob and dyn_blob
    - Added fwDimDefaultConfig dp to the distribution	


Release Notes For FwDIM v13r1:

Linked with:
    - DIM v14r1
Available for:
    - PVSS 2.12, 2.12.1 and 3.0 Official Release

Bug Fixes / Improvements:
    - PVSS00dim now exits gracefully when killed by a DIM
      EXIT command.

Release Notes For FwDIM v13r0:

Linked with:
    - DIM v14r0
Available for:
    - PVSS 2.12, 2.12.1 and 3.0 Official Release

Bug Fixes / Improvements:
    - Updated for PVSS 3.0 Official version

